tic;clc;clear;
global rho z c0 R0 a Ip
c0=2e-7;
%choice=1,EAST,choice=2,ITER,choice=3,HL-2M x1--->rho , x2--> z  
choice=3;
switch choice
    case 1
        a=0.45;R0=1.85;Ip=1e6;  
        x1=[1:0.02:2.6];x2=linspace(-1,1,length(x1));
    case 2
        a=2.0;R0=6.2;Ip=15e6;
        x1=[3:0.1:9];x2=linspace(-3,3,length(x1));
    case 3
        a=0.65;R0=1.78;Ip=3e6;
        x1=[0.8:0.02:2.6];x2=linspace(-1,1,length(x1));
end
for i1=1:length(x1)
    for i2=1:length(x2)
        z=x2(i2);
        rho=x1(i1);
        Brho=integral2(@whatBrho,0,a,0,2*pi);
        Bz=integral2(@whatBz,0,a,0,2*pi);
        B(i1,i2)=sqrt(Brho^2+Bz^2);
    end
end
%άͼ
plot(x1,B);
xlabel(['\fontname{Arial}R']);
ylabel(['\fontname{Arial}Bp']);
%zlabel(['\fontname{Arial}z']);
set(gca,'FontSize',20);  
%άͼ
% mesh(x1,x2,B');
% axis tight;
%xlabel(['\fontname{Arial}R']);
%ylabel(['\fontname{Arial}Z']);
%zlabel(['\fontname{Arial}Bp']);
% set(gca,'FontSize',20);         %set axis size
% disp(['calculation time ' num2str(toc) 's']);
% savefiles(choice);
% disp(['total time ' num2str(toc) 's']);

function B_rho=whatBrho(r,theta)
global c0 z rho 
[A1,~,A3,dd,J,E,K]=parameter(r,theta);
B_rho=c0*J.*r.*(z-r.*sin(theta)).*(A1./A3.*E-K)./(rho*dd);
end
function B_z=whatBz(r,theta)
global c0
[~,A2,A3,dd,J,E,K]=parameter(r,theta);
B_z=c0*J.*r.*(A2./A3.*E+K)./dd;
end
%жһЩ
function [A1,A2,A3,dd,J,E,K]=parameter(r,theta)
% thetaΪģµtheta,rҲµr
global rho z a R0 Ip
J=Ip/pi/a^2;                %dian liu jun yun
%J=J*(1-r.^2./a^2);         %fei jun yun
%޸ĺR,Z,Բ
R=R0+r.*cos(theta);
Z=z-r.*sin(theta);
%ԲĳЩrй
%R=R0-b+(a+b*cos(theta))*cos(theta+delta*sin(theta));
%Z=k*a*sin(theta);
k2=4*R*rho./((R+rho).^2+Z.^2);
k2=k2-eps;
[K,E]=ellipke(k2);
dd=sqrt((R+rho).^2+Z.^2);
A1=R.^2+rho^2+Z.^2;
A2=R.^2-rho^2-Z.^2;
A3=(R-rho).^2+Z.^2;
A3=A3+1e-3;     %ĸ
end
function savefiles(choice)
time=datestr(now,30);
switch choice
    case 1
        print(gcf,['Coarse_Current_Loop_EAST_',time,'.eps'],'-depsc','-r600')
        savefig(['Coarse_Current_Loop_EAST_',time,'.fig'])
        print(gcf,['Coarse_Current_Loop_EAST_',time,'.png'],'-dpng')
    case 2
        print(gcf,['Coarse_Current_Loop_ITER_',time,'.eps'],'-depsc','-r600')
        savefig(['Coarse_Current_Loop_ITER_',tme,'.fig'])
        print(gcf,['Coarse_Current_Loop_ITER_',time,'.png'],'-dpng')
    case 3
        print(gcf,['Coarse_Current_Loop_HL_2M_',time,'.eps'],'-depsc','-r600')
        savefig(['Coarse_Current_Loop_HL_2M_',time,'.fig'])
        print(gcf,['Coarse_Current_Loop_HL_2M_',time,'.png'],'-dpng')
end
end