function [Bx,By,Bz]=Tokamak_Magnetic(x,y,z)
% Բпװãĳλãشųķ
    c0=2e-7;
    %HL-2M
    Ip=3e6;a=0.65;R0=1.78;B0=3.0;
    %ITER
    %Ip=15e6;R0=6.2;a=2.0;B0=5.3;
    rho=sqrt(x^2+y^2);
    theta=atan2(y,x);
    j=Ip/pi/a^2;
    J=@(r,phi)j;       %
    J=@(r,phi)J(r,phi)*(1-r.^2./a^2); %Ǿ
    k2=@(r,phi)4*(R0+r.*cos(phi)).*rho./((R0+r.*cos(phi)+rho).^2+(z-r.*sin(phi)).^2);
    k2=@(r,phi)k2(r,phi)-eps*(k2(r,phi)==1); 
    K=@(r,phi)KK(k2(r,phi));
    E=@(r,phi)EE(k2(r,phi));
    dd=@(r,phi)sqrt((R0+r.*cos(phi)+rho).^2+(z-r.*sin(phi)).^2);
    A1=@(r,phi)(R0+r.*cos(phi)).^2+rho^2+(z-r.*sin(phi)).^2;
    A2=@(r,phi)(R0+r.*cos(phi)).^2-rho^2-(z-r.*sin(phi)).^2;     
    A3_0=@(r,phi)(R0+r.*cos(phi)-rho).^2+(z-r.*sin(phi)).^2;
    A3=@(r,phi)A3_0(r,phi)+1e-3;        %if A3=0,c/0=inf
    B_rho=@(r,phi)c0*J(r,phi).*r.*(z-r.*sin(phi)).*(A1(r,phi)./A3(r,phi).*E(r,phi)-K(r,phi))./((rho+eps*(rho==0)).*dd(r,phi));
    B_theta=B0*R0/rho;
    B_z=@(r,phi)c0*J(r,phi).*r.*(A2(r,phi)./A3(r,phi).*E(r,phi)+K(r,phi))./dd(r,phi);
    Brho=integral2(B_rho,0,a,0,2*pi);  
    Btheta=B_theta;
    Bz=integral2(B_z,0,a,0,2*pi);
    Bx=Brho*cos(theta)-Btheta*sin(theta);
    By=Brho*sin(theta)+Btheta*cos(theta);
end
function K=KK(k2)
    [K,E]=ellipke(k2);
end function E=EE(k2)
    [K,E]=ellipke(k2);
end